local dewdrop = AceLibrary("Dewdrop-2.0")
local L = AceLibrary("AceLocale-2.2"):new("Click2Cast")

local buttons = {"1","2","3","4","5"}
local modifiers = {"None","Alt","Ctrl","Shift",}
local actions = {"menu","spell","target","focus","assist","macro","none"}

function Click2Cast:CreateMenu()
    self.optionsTable = {
        handler = Click2Cast,
        type = 'group',
        args = {},
    }

    for k,v in ipairs(buttons) do
        local button = v
        local orderLocal = k
        self.optionsTable.args["button"..v] = {
                type = 'group',
                name = L["Mouse "..button],
                desc = L["Mouse "..button.."Desc"],
                order = orderLocal,
                args = Click2Cast:GetButtonArgTable(button)
        }
    end
    
    Click2Cast:RegisterChatCommand({ "/Click2Cast", "/c2c", "/cc" }, self.optionsTable)
    Click2Cast.OnMenuRequest = self.optionsTable
end

function Click2Cast:GetButtonArgTable(button)
    local table = {}
    local button = button
    
    for k,v in ipairs(modifiers) do
        local modifier = v
        local orderLocal = k        
        table[v] = {
            type = 'group',
            name = L[modifier],
            desc = L[modifier.."Desc"],
            order = orderLocal,
            args = {
                actions = {
                    type = 'text',
                    name = L["Set Action"],
                    desc = L["actions"],
                    order = 1,
                    validate = actions,
                    get = function() 
                        return self.db.profile.clickOptions[modifier.."-"..button].action or "none" 
                    end,
                    set = function(option)
                        self.db.profile.clickOptions[modifier.."-"..button].action = option
                        self:EnableFrames()
                    end,
                },
                action = {
                    name = L["Action Text"],
                    type = 'text',
                    desc = L["actiontext"],
                    get = function()
                        return self.db.profile.clickOptions[modifier.."-"..button].actiontext or ""
                    end,
                    usage = "",
                    set = function(option)
                        self.db.profile.clickOptions[modifier.."-"..button].actiontext = option
                        self:EnableFrames()
                    end,
                }
            }
        }
    end
    
    return table
end
